// SMTPMailer.h

#ifndef __SMTPMAILER_H__
#define __SMTPMAILER_H__

#include <unknwn.h>

#ifdef SMTPMAILER32_EXPORTS
#define SMTPMAILER32_API __declspec(dllexport)
#else
#define SMTPMAILER32_API __declspec(dllimport)
#endif

//******* GUIDs ****************************************************************

static const GUID IID_ISMTPMailerMessage =
{ 0x602D0664, 0x5FD9, 0x21CE, { 0x23, 0x9E, 0x88, 0x85, 0x86, 0x2E, 0x1E, 0x31 } };

static const GUID IID_ISMTPMailer =
{ 0x602D03D4, 0xFFD9, 0x21CE, { 0xC3, 0x9E, 0x88, 0xE5, 0x86, 0x2E, 0xAE, 0x3E } };

//********** Interfaces ********************************************************

DECLARE_INTERFACE(ISMTPMailerMessage)
{
  /* IUnknown methods */
  STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR * ppvObj) PURE;
  STDMETHOD_(ULONG,AddRef) (THIS)  PURE;
  STDMETHOD_(ULONG,Release) (THIS) PURE;
  /* ISMTPMailerMessage methods */
  STDMETHOD(SetFromAddress)(char* pFromAddress) PURE;
  STDMETHOD(SetFromName)(char* pFromName) PURE;
  STDMETHOD(AddToAddress)(char* pToAddress) PURE;
  STDMETHOD(SetSubject)(char* pSubject) PURE;
  STDMETHOD(AddBody)(char* pBody) PURE;
  STDMETHOD(AddAttachment)(char* pAttachment) PURE;
};

DECLARE_INTERFACE(ISMTPMailer)
{
  /* IUnknown methods */
  STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR * ppvObj) PURE;
  STDMETHOD_(ULONG,AddRef) (THIS)  PURE;
  STDMETHOD_(ULONG,Release) (THIS) PURE;
  /* ISMTPMailer methods */
  STDMETHOD(Connect)(char* pHost) PURE;
  STDMETHOD(Send)(ISMTPMailerMessage* pMessage) PURE;
  STDMETHOD(Disconnect)() PURE;
};

//*********  SMTPMailer32.dll Exports ***************************************************************************

extern "C" SMTPMAILER32_API HRESULT __stdcall CreateMailerObject(const GUID* lpIID,
                                                                 IUnknown**  ppiUnk);


#endif // __SMTPMAILER_H__

